package readingtextfile;

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class ReadingTextFile {

    StringBuilder fileContents = new StringBuilder();
    public static void main(String[] args) {
        new ReadingTextFile();
    }
    
    public ReadingTextFile() {
      
        // A Scanner is used for both the keyboard input and the file
        // input.  The only difference is in the argument to the constructor.
        Scanner keyIn = new Scanner(System.in);

        // requesting text file name to be opened
        Scanner fileIn = requestInputFile(keyIn);
        if (fileIn == null) {
            System.exit(0);
        }
        
        // printing file contents
        fileContents = loadingFileContents(fileIn);
        
        // printing file contents
        System.out.println(fileContents.toString());
        
        // requesting output file
        PrintWriter fileOut = requestOutputFile(keyIn);
        if (fileOut == null) {
            System.exit(0);
        }
        
        // saving data found in the StringBuilder
        dumpContents(fileContents, fileOut);

        // house keeping - closing all opened files
        fileIn.close();
        fileOut.close();
    }

    private Scanner requestInputFile(Scanner keyIn) {
        System.out.print("Input file name (X to quit): ");
        String fName = keyIn.nextLine();

        if (fName.equalsIgnoreCase("x")) {
            return null;
        }

        File inFile = null;
        Scanner fileIn = null;
        boolean validFile = false;
        while(!validFile) {
            inFile = new File(fName);
            try {
                fileIn = new Scanner(inFile);
                validFile = true;
            } catch (Exception e) {
                System.out.println("Invalid file: " + inFile + "." 
                        + "\nPlease try again.");
            }
        }
        return fileIn;
    }

    private void dumpContents(StringBuilder fileContents, PrintWriter fileOut) {
        fileOut.print(fileContents.toString());
    }
    
    private StringBuilder loadingFileContents(Scanner fileIn) {
        StringBuilder tempStringBuilder = new StringBuilder();
        while(fileIn.hasNext()) {
            String line = fileIn.nextLine();
            tempStringBuilder.append(line + "\n");
        }
        
        return tempStringBuilder;
    }

    private PrintWriter requestOutputFile(Scanner keyboard) {
        PrintWriter fileOut = null;
        System.out.print("Output file name: ");
        String fName = keyboard.nextLine();
        try {
            fileOut = new PrintWriter(fName);
        } catch (Exception e) {
            int k = 0;
        }
        return fileOut;
    }
}
